﻿-- Author      : Apoco
-- Create Date : 2/20/2008 1:03:23 PM
-- Small Mod to Automatically hook Nurfed's Cooldown Timers to AutoBar.
-- Reason: I got tired of manually editing autobar files everytime a lib got updated.  lol
if not cooldowntext and not nrfcooldowntext then
	for i=1,5 do
		if getglobal("ChatFrame"..i):IsShown() then
			local f = getglobal("ChatFrame"..i)
			f:AddMessage("Nurfed_AutoBarHook: ERROR!  You need to edit Nurfed/Libs/ActionBars.lua file for this to work.", 1, 0, 0)
			f:AddMessage("-- Find line: \"local cooldowntext = function(btn)\" and replace with: \"cooldowntext = function(btn)\"", 1, 0, 0)
		end
	end
	return
end
if not IsAddOnLoaded("Nurfed") and not IsAddOnLoaded("AutoBar") then
	return
end

local t = { }
local autobarhookpopup = function(...)
	for i in pairs(t) do
		t[i] = nil
	end
	for i in pairs(AutoBarButton.dirtyButton) do
		for e=1,15 do	-- assumes you will have a max of 15 popups...don't see why you could even come close to that though.
			if getglobal(i.."FramePopup"..e) then
				if getglobal(i.."FramePopup"..e).cooldown.text and getglobal(i.."FramePopup"..e):GetScript("OnUpdate") then
					break
				end
				t[i.."FramePopup"..e] = true
			end
			if getglobal("AutoBarButtonCustom"..i.."FramePopup"..e) then
				t["AutoBarButtonCustom"..i.."FramePopup"..e] = true
			end
		end
	end

	for frame in pairs(t) do
		local frame = getglobal(frame)
		local itemId = frame:GetAttribute("itemId")
		if (itemId) then
			if not frame.cooldown.text then
				frame.cooldown.text = frame.cooldown:CreateFontString(nil, "OVERLAY")
				frame.cooldown.text:SetPoint("CENTER")
				frame.cooldown.text:SetFont("Fonts\\FRIZQT__.TTF", 22, "OUTLINE")
				frame:SetScript("OnUpdate", cooldowntext)
			end
		end
	end
end

local tx = { }
local autobarhookbutton = function(...)
	for i in pairs(tx) do
		tx[i] = nil
	end
	for i in pairs(AutoBarButton.dirtyButton) do
		if getglobal(i.."Frame") then
			if getglobal(i.."Frame"):IsShown() then
				if getglobal(i.."Frame").cooldown.text and getglobal(i.."Frame"):GetScript("OnUpdate") then
					break
				end
				tx[i.."Frame"] = true
			end
		end
		if getglobal("AutoBarButtonCustom"..i.."Frame") then
			if getglobal("AutoBarButtonCustom"..i.."Frame"):IsShown() then
				tx["AutoBarButtonCustom"..i.."Frame"] = true
			end
		end
	end

	for frame in pairs(tx) do
		local frame = getglobal(frame)
		local itemId = frame:GetAttribute("itemId")
		if (itemId) then
			if not frame.cooldown.text then
				frame.cooldown.text = frame.cooldown:CreateFontString(nil, "OVERLAY")
				frame.cooldown.text:SetPoint("CENTER")
				frame.cooldown.text:SetFont("Fonts\\FRIZQT__.TTF", 22, "OUTLINE")
				frame:SetScript("OnUpdate", cooldowntext)
			end
		end
	end
end


if IsAddOnLoaded("Nurfed") and IsAddOnLoaded("AutoBar") and not IsAddOnLoaded("OmniCC") and not IsAddOnLoaded("CooldownCount") then
	hooksecurefunc(AutoBar.Class.Button.prototype, "UpdateCooldown", autobarhookbutton)
	hooksecurefunc(AutoBar.Class.PopupButton.prototype, "UpdateCooldown", autobarhookpopup)
end